package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.4.2 from the manual.
 *  @version $Id: ADDORDERMPIDMessageProcessor.java,v 1.20 2012/08/15 16:47:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class ADDORDERMPIDMessageProcessor extends MessageProcessor {


    static class ADDORDERMPIDMessage extends ITCHMessage {
	final long orderreferencenumber;
	final int buy_sell_indicator;
	final int shares;
	final String stock;
	final double price;
	final String attribution;

	ADDORDERMPIDMessage(final long time,
			    final long orderreferencenumber,
			    final int buy_sell_indicator,
			    final int shares,
			    final String stock,
			    final double price,
			    final String attribution)

	{
	    super(time);
	    this.orderreferencenumber=orderreferencenumber;
	    this.buy_sell_indicator=buy_sell_indicator;
	    this.shares=shares;
	    this.stock=stock;
	    this.price=price;
	    this.attribution=attribution;
	}

	String dumpData()
	{
	    return "ADDORDERMPIDMessage:"+com.polytechnik.realtimebook.BookItem.getTimeDiag(time)+":"+
		" orderreferencenumber="+orderreferencenumber+
		" buy_sell_indicator="+((char)buy_sell_indicator)+
		" shares="+shares+
		" price="+price+
		" stock="+stock+
		" attribution="+attribution;
	}
    }


    ADDORDERMPIDMessageProcessor(final ITCHParser parser)
    {
	super('F',new int []{1,5,13,14,18,26,30,34},parser);
    }


    public ADDORDERMPIDMessage getMessage(final byte [] buf,final int b_start)
    {
	final int v_buy_sell_indicator=getChar(buf,b_start,3);
	validateChar(v_buy_sell_indicator,validate_buy_sell_indicator,"BUY SELL",buf,b_start);

	return new ADDORDERMPIDMessage(this.parser.getTime(),
				       getLong(buf,b_start,2),
				       v_buy_sell_indicator,
				       getInteger(buf,b_start,4),
				       getString(buf,b_start,5),
				       getPrice(buf,b_start,6),
				       getString(buf,b_start,7));
    }



    public void processMessage(final byte [] buf,final int b_start)
    {
	this.parser.addOrder(getMessage(buf,b_start));
    }
}
