package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.6.3 from the manual.
 *  @version $Id: BROKENTRADEMessageProcessor.java,v 1.11 2012/08/15 16:47:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class BROKENTRADEMessageProcessor extends MessageProcessor {


    static class BROKENTRADEMessage extends ITCHMessage {
	final long matchnumber;

	BROKENTRADEMessage(final long time,
			   final long matchnumber)
	{
	    super(time);
	    this.matchnumber=matchnumber;
	}
	String dumpData()
	{
	    return "BROKENTRADEMessageProcessor:"+com.polytechnik.realtimebook.BookItem.getTimeDiag(time)+":"+
		" matchnumber="+matchnumber;
	}
    }


    BROKENTRADEMessageProcessor(final ITCHParser parser)
    {
	super('B',new int []{1,5,13},parser);
    }


    public BROKENTRADEMessage getMessage(final byte [] buf,final int b_start)
    {
	return new BROKENTRADEMessage(this.parser.getTime(),
				      getLong(buf,b_start,2));
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	this.parser.processBrokenTrade(getMessage(buf,b_start));
    }
}
