package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.realtimebook.*;

/** A trader that does nothing.
    java -server -Xmx6500000K com/polytechnik/itch/DummyTrader /rdata/itch/itch4/S012309-v4.txt.gz
 *  @version $Id: DummyTrader.java,v 1.12 2011/10/18 16:51:58 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class DummyTrader implements TraderInterface {


    static final long TIME_KEEP_TRADES=600*TraderInterface.TIME_SCALE;

    public void allowTrading(final OrdersAndTrades ot,final long currenttime,final int value,final String text){}


    public void allowTrading(final long currenttime,final boolean on_off){}


    public void setInstrument(final OrdersAndTrades ot,
			      final long currenttime,
			      final boolean flag_statusOK,
			      final int round_lot_shares,
			      final boolean round_lot_only,
			      final String market){}


    public void setMarketMaker(final OrdersAndTrades ot,
			       final long currenttime,
			       final String mpid,
			       final boolean flag_primary,
			       final boolean flag_ok){}



   public void update(final OrdersAndTrades ot,
		      final long currenttime,
		      final int eventid){

       final long tb=currenttime-TIME_KEEP_TRADES;
       if(tb>0)
       {
	   ot.clearBefore(tb);
       }
       // DO NOTHING
   }


    public ITCHParser runParser(final String file) throws java.io.IOException
    {
	final long tt0=System.currentTimeMillis();
	System.err.println("Processing file="+file+" by $Id: DummyTrader.java,v 1.12 2011/10/18 16:51:58 mal Exp $");
	final com.polytechnik.itch.ITCHParser parser=
	    new  com.polytechnik.itch.ITCHParser(this);
	new com.polytechnik.itch.FileFeeder(parser,file).processStream();

	final long tt1=System.currentTimeMillis();
	System.err.println("Processing file="+file+" is DONE in "+(tt1-tt0)+
			   " milliseconds by $Id: DummyTrader.java,v 1.12 2011/10/18 16:51:58 mal Exp $");
	System.err.flush();
	return parser;
    }

    public static void main(String [] args)
	throws Exception
    {
	if(args.length<1)
	{
	    System.err.println("DummyTrader itch_file_1 itch_file_2 ... ");
	}
	else
	{
	    final long t0=System.currentTimeMillis();
	    int n=0;
	    for(int i=0;i<args.length;i++)
	    {
		final String f=args[i];

		final DummyTrader t=new DummyTrader();
		t.runParser(f);

		n++;
	    }
	    System.err.println("Processed "+n+" files in "+
			       ((System.currentTimeMillis()-t0)/1000L)+
			       " seconds. by $Id: DummyTrader.java,v 1.12 2011/10/18 16:51:58 mal Exp $");
	}
    }







}
