package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.5.3 from the manual.
 *  @version $Id: ORDERCANCELLEDMessageProcessor.java,v 1.12 2008/10/26 19:33:51 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class ORDERCANCELLEDMessageProcessor extends MessageProcessor {


    static class ORDERCANCELLEDMessage extends ITCHMessage {
	final long orderreferencenumber;
	final int shares;

	ORDERCANCELLEDMessage(final long time,
			      final long orderreferencenumber,
			      final int shares)


	{
	    super(time);
	    this.orderreferencenumber=orderreferencenumber;
	    this.shares=shares;
	}
    }


    ORDERCANCELLEDMessageProcessor(final ITCHParser parser)
    {
	super('X',new int []{1,5,13,17},parser);
    }


    public ORDERCANCELLEDMessage getMessage(final byte [] buf,final int b_start)
    {
	return new ORDERCANCELLEDMessage(this.parser.getTime(),
					 getLong(buf,b_start,2),
					 getInteger(buf,b_start,3));
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	this.parser.cancelOrder(getMessage(buf,b_start));
    }
}
