package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.5.4 from the manual.
 *  @version $Id: ORDERDELETEMessageProcessor.java,v 1.14 2012/08/15 16:47:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class ORDERDELETEMessageProcessor extends MessageProcessor {


    static class ORDERDELETEMessage extends ITCHMessage {
	final long orderreferencenumber;

	ORDERDELETEMessage(final long time,
			   final long orderreferencenumber)


	{
	    super(time);
	    this.orderreferencenumber=orderreferencenumber;
	}
	String dumpData()
	{
	    return "ORDERDELETEMessage:"+com.polytechnik.realtimebook.BookItem.getTimeDiag(time)+":"+
		" orderreferencenumber="+orderreferencenumber;
	}
    }

    ORDERDELETEMessageProcessor(final ITCHParser parser)
    {
	super('D',new int []{1,5,13},parser);
    }


    public ORDERDELETEMessage getMessage(final byte [] buf,final int b_start)
    {
	return new ORDERDELETEMessage(this.parser.getTime(),
				      getLong(buf,b_start,2));
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	this.parser.deleteOrder(getMessage(buf,b_start));
    }
}
