package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.5.2 from the manual.
 *  @version $Id: ORDEREXECUTEDWITHPRICEMessageProcessor.java,v 1.20 2012/08/15 16:47:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class ORDEREXECUTEDWITHPRICEMessageProcessor extends MessageProcessor {


    static class ORDEREXECUTEDWITHPRICEMessage extends ITCHMessage {
	final long orderreferencenumber;
	final int shares;
	final long matchnumber;
	final int printable;
	final double executionprice;

	ORDEREXECUTEDWITHPRICEMessage(final long time,
				      final long orderreferencenumber,
				      final int shares,
				      final long matchnumber,
				      final int printable,
				      final double executionprice)


	{
	    super(time);
	    this.orderreferencenumber=orderreferencenumber;
	    this.shares=shares;
	    this.matchnumber=matchnumber;
	    this.printable=printable;
	    this.executionprice=executionprice;
	}

	String dumpData()
	{
	    return "ORDEREXECUTEDWITHPRICEMessageProcessor:"+com.polytechnik.realtimebook.BookItem.getTimeDiag(time)+":"+
		" orderreferencenumber="+orderreferencenumber+
		" shares="+shares+
		" matchnumber="+matchnumber+
		" executionprice="+executionprice+
		" printable="+((char)printable);
	}
    }


    ORDEREXECUTEDWITHPRICEMessageProcessor(final ITCHParser parser)
    {
	super('C',new int []{1,5,13,17,25,26,30},parser);
    }


    public ORDEREXECUTEDWITHPRICEMessage getMessage(final byte [] buf,final int b_start)
    {
	final int v_printable=getChar(buf,b_start,5);
	validateChar(v_printable,validate_yes_no,"PRINTABLE",buf,b_start);

	return new ORDEREXECUTEDWITHPRICEMessage(
	    this.parser.getTime(),
	    getLong(buf,b_start,2),
	    getInteger(buf,b_start,3),
	    getLong(buf,b_start,4),
	    v_printable,
	    getPrice(buf,b_start,6));
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	// what should we do with non-printable execution messages?
	this.parser.executeOrder(getMessage(buf,b_start));
    }
}
