package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.realtimebook.*;

/** Item 4.3.3 from the manual.
 *  @version $Id: REGSHOACTIONMessageProcessor.java,v 1.3 2011/10/18 16:51:58 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class REGSHOACTIONMessageProcessor extends MessageProcessor {

    static final int
	NO_PRICE_TEST='0',
	REG_SHO_SHORT_SALE='1',
	REG_SHO_SHORT_SALE_REMAINS='2';

    // all false by default
    private static final boolean []
	validate_regshoaction=new boolean [MAX_N_CHAR_ARRAY_SIZE];
    static {
	validate_regshoaction[NO_PRICE_TEST]=true;
	validate_regshoaction[REG_SHO_SHORT_SALE]=true;
	validate_regshoaction[REG_SHO_SHORT_SALE_REMAINS]=true;
    }


    static class REGSHOACTIONMessage extends ITCHMessage {
	final String stock;
	final int regshoaction;

	REGSHOACTIONMessage(final long time,
			    final String stock,
			    final int regshoaction)
	{
	    super(time);
	    this.stock=stock;
	    this.regshoaction=regshoaction;
	}
    }

    private final TraderInterface trader;
    REGSHOACTIONMessageProcessor(final ITCHParser parser,
				 final TraderInterface trader)
    {
	super('Y',new int []{1,5,13,14},parser);
	this.trader=trader;
    }


    public REGSHOACTIONMessage getMessage(final byte [] buf,final int b_start)
    {
	final int v_regshoaction=getChar(buf,b_start,3);
	validateChar(v_regshoaction,validate_regshoaction,"REG SHO ACTION",buf,b_start);

	return new REGSHOACTIONMessage(this.parser.getTime(),
				       getString(buf,b_start,2),
				       v_regshoaction);
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	final REGSHOACTIONMessage m=getMessage(buf,b_start);
	final OrdersAndTrades ot=this.parser.tradesbuilder.initTicker(m.stock);
	if(true) //synchronized(ot.ticker)
	{
	    this.trader.allowTrading(ot,m.time,m.regshoaction==NO_PRICE_TEST?TraderInterface.SEC_SHORT_NO_RES:TraderInterface.SEC_SHORT_RES,"REGSHOACTION:ACTION="+((char)m.regshoaction));
	}
    }
}
