package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.5.5 from the manual.
 *  @version $Id: REPLACEORDERMessageProcessor.java,v 1.7 2012/08/15 16:47:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class REPLACEORDERMessageProcessor extends MessageProcessor {


    static class REPLACEORDERMessage extends ITCHMessage {
	final long original_orderreferencenumber;
	final long new_orderreferencenumber;
	final int shares;
	final double price;

	REPLACEORDERMessage(final long time,
			    final long original_orderreferencenumber,
			    final long new_orderreferencenumber,
			    final int shares,
			    final double price)
	{
	    super(time);
	    this.original_orderreferencenumber=original_orderreferencenumber;
	    this.new_orderreferencenumber=new_orderreferencenumber;
	    this.shares=shares;
	    this.price=price;
	}
	String dumpData()
	{
	    return "REPLACEORDERMessageProcessor:"+com.polytechnik.realtimebook.BookItem.getTimeDiag(time)+":"+
		" original_orderreferencenumber="+original_orderreferencenumber+
		" new_orderreferencenumber="+new_orderreferencenumber+
		" shares="+shares+
		" price="+price;
	}
    }


    REPLACEORDERMessageProcessor(final ITCHParser parser)
    {
	super('U',new int []{1,5,13,21,25,29},parser);
    }


    public REPLACEORDERMessage getMessage(final byte [] buf,final int b_start)
    {

	return new REPLACEORDERMessage(this.parser.getTime(),
				       getLong(buf,b_start,2),
				       getLong(buf,b_start,3),
				       getInteger(buf,b_start,4),
				       getPrice(buf,b_start,5));
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	this.parser.replaceOrder(getMessage(buf,b_start));
    }
}
