package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.8 from the manual.
 *  @version $Id: RPIIMessageProcessor.java,v 1.1 2016/03/23 17:27:29 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class RPIIMessageProcessor extends MessageProcessor {

    static final int
        INTEREST_FLAG_BUY='B',
        INTEREST_FLAG_SELL='S',
        INTEREST_FLAG_BOTHSIDES='A',
        INTEREST_FLAG_NOORDERS='N';


     // all false by default
    private static final boolean [] validate_interest_flag=new boolean [MAX_N_CHAR_ARRAY_SIZE];
    static {
	validate_interest_flag[INTEREST_FLAG_BUY]=true;
        validate_interest_flag[INTEREST_FLAG_SELL]=true;
        validate_interest_flag[INTEREST_FLAG_BOTHSIDES]=true;
        validate_interest_flag[INTEREST_FLAG_NOORDERS]=true;
    }


    static class RPIIMessage extends ITCHMessage {
	final String stock;
	final int interst_flag;


	RPIIMessage(final long time,
		    final String stock,
		    final int interst_flag)
	{
	    super(time);
	    this.stock=stock;
	    this.interst_flag=interst_flag;
	}
    }


    RPIIMessageProcessor(final ITCHParser parser)
    {
	super('N',new int []{1,5,13,14},parser);
    }


    public RPIIMessage getMessage(final byte [] buf,final int b_start)
    {
	final int interst_flag=getChar(buf,b_start,3);
	validateChar(interst_flag,validate_interest_flag,"INTEREST FLAG",buf,b_start);

	return new RPIIMessage(
	    this.parser.getTime(),
	    getString(buf,b_start,2),
	    interst_flag);
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	final RPIIMessage m=getMessage(buf,b_start);
	// I am not sure what to do with a messages of this type
    }
}
