package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** Item 4.1 from the manual.
 *  @version $Id: SECONDMessageProcessor.java,v 1.30 2011/10/18 12:23:30 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class SECONDMessageProcessor extends MessageProcessor {

    SECONDMessageProcessor(final ITCHParser parser)
    {
	super('T',new int []{1,5},parser);
    }

    public ITCHMessage getMessage(final byte [] buf,final int b_start)
    {
	throw new RuntimeException("Should never be called");
    }

    public void processMessage(final byte [] buf,final int b_start)
    {
	final long onseconds=this.parser.nseconds;
	if((this.parser.nseconds=ITCHParser.SECOND_CONVERSION_SCALE*getInteger(buf,b_start,1))<onseconds)
	{
	    throw new IllegalArgumentException(
		"!!!!!!DATA ERROR:Time go backward nsecond="+this.parser.nseconds+
		" < "+onseconds+" input="+ITCHParser.getBytesAsString(buf,b_start,getLength()));
	}

	this.parser.nanoseconds=0L;
    }
}
