package com.polytechnik.itch;


/** A class to dump read data and call second StreamProcessor.
 *  Used for unit tests.
 *  @version $Id: StreamProcessorDumpData.java,v 1.2 2011/10/15 11:10:42 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class StreamProcessorDumpData implements StreamProcessor {
    private final java.io.OutputStream out;
    private final StreamProcessor processor2;
    public StreamProcessorDumpData(final java.io.OutputStream out,
				   final StreamProcessor processor2)
    {
	this.out=out;
	this.processor2=processor2;
    }

    public int process(final byte [] buf,final int b_start,final int b_len)
    {
	try {
	    out.write(buf,b_start,b_len);
	}catch(final java.io.IOException ioe) {
	    ioe.printStackTrace(System.err);
	    throw new RuntimeException("Cannot process");
	}
	// run second procesor
	if(processor2!=null)
	    return processor2.process(buf,b_start,b_len);
	return b_len;
    }
}

