package com.polytechnik.itch;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Item 4.6.1 from the manual.
 *  @version $Id: TRADEMESSAGEMessageProcessor.java,v 1.18 2012/08/15 16:47:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class TRADEMESSAGEMessageProcessor extends MessageProcessor {


    static class TRADEMESSAGEMessage extends ITCHMessage {
	final long orderreferencenumber;
	final int buy_sell_indicator;
	final int shares;
	final String stock;
	final double price;
	final long matchnumber;

	TRADEMESSAGEMessage(final long time,
			    final long orderreferencenumber,
			    final int buy_sell_indicator,
			    final int shares,
			    final String stock,
			    final double price,
			    final long matchnumber)

	{
	    super(time);
	    this.orderreferencenumber=orderreferencenumber;
	    this.buy_sell_indicator=buy_sell_indicator;
	    this.shares=shares;
	    this.stock=stock;
	    this.price=price;
	    this.matchnumber=matchnumber;
	}
	String dumpData()
	{
	    return "TRADEMESSAGEMessageProcessor:"+com.polytechnik.realtimebook.BookItem.getTimeDiag(time)+":"+
		" orderreferencenumber="+orderreferencenumber+
		" buy_sell_indicator="+((char)buy_sell_indicator)+
		" shares="+shares+
		" price="+price+
		" matchnumber="+matchnumber+
		" stock="+stock;
	}
    }


    TRADEMESSAGEMessageProcessor(final ITCHParser parser)
    {
	super('P',new int []{1,5,13,14,18,26,30,38},parser);
    }


    public TRADEMESSAGEMessage getMessage(final byte [] buf,final int b_start)
    {
	final int v_buy_sell_indicator=getChar(buf,b_start,3);
	validateChar(v_buy_sell_indicator,validate_buy_sell_indicator,"BUY SELL",buf,b_start);

	return new TRADEMESSAGEMessage(this.parser.getTime(),
				       getLong(buf,b_start,2),
				       v_buy_sell_indicator,
				       getInteger(buf,b_start,4),
				       getString(buf,b_start,5),
				       getPrice(buf,b_start,6),
				       getLong(buf,b_start,7));
    }


    public void processMessage(final byte [] buf,final int b_start)
    {
	this.parser.executeNonDisplayableOrder(getMessage(buf,b_start));
    }
}
