/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dlapy2.f
 *  f2java version: 0.8.1
 *
 *  Manually adjusted by
 *  @author Vladislav Malyshkin mal@gromco.com
 *  @version $Id: Dlapy2.java,v 1.4 2012/12/20 18:15:50 mal Exp $
 *
 */

package com.polytechnik.lapack;



public class Dlapy2 {

// *> \brief \b DLAPY2 returns sqrt(x2+y2).
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at 
// *            http://www.netlib.org/lapack/explore-html/ 
// *
// *> \htmlonly
// *> Download DLAPY2 + dependencies 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a> 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a> 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly 
// *
// *  Definition:
// *  ===========
// *
// *       DOUBLE PRECISION FUNCTION DLAPY2( X, Y )
// * 
// *       .. Scalar Arguments ..
// *       DOUBLE PRECISION   X, Y
// *       ..
// *  
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DLAPY2 returns sqrt(x**2+y**2), taking care not to cause unnecessary

// *> overflow.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] X
// *> \verbatim
// *>          X is DOUBLE PRECISION
// *> \endverbatim
// *>
// *> \param[in] Y
// *> \verbatim
// *>          Y is DOUBLE PRECISION
// *>          X and Y specify the values x and y.
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee 
// *> \author Univ. of California Berkeley 
// *> \author Univ. of Colorado Denver 
// *> \author NAG Ltd. 
// *
// *> \date September 2012
// *
// *> \ingroup auxOTHERauxiliary
// *
// *  =====================================================================
// 
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
***/

public static double dlapy2 (double x,
double y)  {

double dlapy2= 0.0d;
double w= 0.0d;
double xabs= 0.0d;
double yabs= 0.0d;
double z= 0.0d;
xabs = Math.abs(x);
yabs = Math.abs(y);
w = Math.max(xabs, yabs);
z = Math.min(xabs, yabs);
if ((z == 0.0))  {
    dlapy2 = w;
}
else  {
  dlapy2 = (w*Math.sqrt((1.0+( Math.pow(((z/w)), 2)))));
}              //  Close else.
/***
*
*     End of DLAPY2
*
***/
//Dummy.go_to("com/polytechnik/lapack/Dlapy2",999999);
// dummy stmt
//Dummy.label("com/polytechnik/lapack/Dlapy2",999999);
return dlapy2;
   }
} // End class.
