/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dormtr.f
 *  f2java version: 0.8.1
 *
 *
 *  Manually adjusted by
 *  @author Vladislav Malyshkin mal@gromco.com
 *  @version $Id: Dormtr.java,v 1.5 2012/12/19 10:31:23 mal Exp $
 *
 */

package com.polytechnik.lapack;



public class Dormtr {

// *> \brief \b DORMTR
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at 
// *            http://www.netlib.org/lapack/explore-html/ 
// *
// *> \htmlonly
// *> Download DORMTR + dependencies 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a> 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a> 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly 
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE DORMTR( SIDE, UPLO, TRANS, M, N, A, LDA, TAU, C, LDC,
// *                          WORK, LWORK, INFO )
// * 
// *       .. Scalar Arguments ..
// *       CHARACTER          SIDE, TRANS, UPLO
// *       INTEGER            INFO, LDA, LDC, LWORK, M, N
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION   A( LDA, * ), C( LDC, * ), TAU( * ), WORK( * )
// *       ..
// *  
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DORMTR overwrites the general real M-by-N matrix C with
// *>
// *>                 SIDE = 'L'     SIDE = 'R'
// *> TRANS = 'N':      Q * C          C * Q
// *> TRANS = 'T':      Q**T * C       C * Q**T
// *>
// *> where Q is a real orthogonal matrix of order nq, with nq = m if
// *> SIDE = 'L' and nq = n if SIDE = 'R'. Q is defined as the product of
// *> nq-1 elementary reflectors, as returned by DSYTRD:
// *>
// *> if UPLO = 'U', Q = H(nq-1) . . . H(2) H(1);
// *>
// *> if UPLO = 'L', Q = H(1) H(2) . . . H(nq-1).
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] SIDE
// *> \verbatim
// *>          SIDE is CHARACTER*1
// *>          = 'L': apply Q or Q**T from the Left;
// *>          = 'R': apply Q or Q**T from the Right.
// *> \endverbatim
// *>
// *> \param[in] UPLO
// *> \verbatim
// *>          UPLO is CHARACTER*1
// *>          = 'U': Upper triangle of A contains elementary reflectors
// *>                 from DSYTRD;
// *>          = 'L': Lower triangle of A contains elementary reflectors
// *>                 from DSYTRD.
// *> \endverbatim
// *>
// *> \param[in] TRANS
// *> \verbatim
// *>          TRANS is CHARACTER*1
// *>          = 'N':  No transpose, apply Q;
// *>          = 'T':  Transpose, apply Q**T.
// *> \endverbatim
// *>
// *> \param[in] M
// *> \verbatim
// *>          M is INTEGER
// *>          The number of rows of the matrix C. M >= 0.
// *> \endverbatim
// *>
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>          The number of columns of the matrix C. N >= 0.
// *> \endverbatim
// *>
// *> \param[in] A
// *> \verbatim
// *>          A is DOUBLE PRECISION array, dimension
// *>                               (LDA,M) if SIDE = 'L'
// *>                               (LDA,N) if SIDE = 'R'
// *>          The vectors which define the elementary reflectors, as
// *>          returned by DSYTRD.
// *> \endverbatim
// *>
// *> \param[in] LDA
// *> \verbatim
// *>          LDA is INTEGER
// *>          The leading dimension of the array A.
// *>          LDA >= max(1,M) if SIDE = 'L'; LDA >= max(1,N) if SIDE = 'R'
// *> \endverbatim
// *>
// *> \param[in] TAU
// *> \verbatim
// *>          TAU is DOUBLE PRECISION array, dimension
// *>                               (M-1) if SIDE = 'L'
// *>                               (N-1) if SIDE = 'R'
// *>          TAU(i) must contain the scalar factor of the elementary
// *>          reflector H(i), as returned by DSYTRD.
// *> \endverbatim
// *>
// *> \param[in,out] C
// *> \verbatim
// *>          C is DOUBLE PRECISION array, dimension (LDC,N)
// *>          On entry, the M-by-N matrix C.
// *>          On exit, C is overwritten by Q*C or Q**T*C or C*Q**T or C*Q.
// *> \endverbatim
// *>
// *> \param[in] LDC
// *> \verbatim
// *>          LDC is INTEGER
// *>          The leading dimension of the array C. LDC >= max(1,M).
// *> \endverbatim
// *>
// *> \param[out] WORK
// *> \verbatim
// *>          WORK is DOUBLE PRECISION array, dimension (MAX(1,LWORK))
// *>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
// *> \endverbatim
// *>
// *> \param[in] LWORK
// *> \verbatim
// *>          LWORK is INTEGER
// *>          The dimension of the array WORK.
// *>          If SIDE = 'L', LWORK >= max(1,N);
// *>          if SIDE = 'R', LWORK >= max(1,M).
// *>          For optimum performance LWORK >= N*NB if SIDE = 'L', and
// *>          LWORK >= M*NB if SIDE = 'R', where NB is the optimal
// *>          blocksize.
// *>
// *>          If LWORK = -1, then a workspace query is assumed; the routin
// *>          only calculates the optimal size of the WORK array, returns

// *>          this value as the first entry of the WORK array, and no erro
// *>          message related to LWORK is issued by XERBLA.
// *> \endverbatim
// *>
// *> \param[out] INFO
// *> \verbatim
// *>          INFO is INTEGER
// *>          = 0:  successful exit
// *>          < 0:  if INFO = -i, the i-th argument had an illegal value
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee 
// *> \author Univ. of California Berkeley 
// *> \author Univ. of Colorado Denver 
// *> \author NAG Ltd. 
// *
// *> \date November 2011
// *
// *> \ingroup doubleOTHERcomputational
// *
// *  =====================================================================
// 
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
***/
/***
*     ..
*     .. External Functions ..
***/
/***
*     ..
*     .. External Subroutines ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
***/

public static void dormtr (final char side,
final char uplo,
final char trans,
int m,
int n,
double [] a, int _a_offset,
int lda,
double [] tau, int _tau_offset,
double [] c, int _c_offset,
int ldc,
double [] work, int _work_offset,
int lwork,
intW info)  {

boolean left= false;
boolean lquery= false;
boolean upper= false;
int i1= 0;
int i2= 0;
int lwkopt= 0;
int mi= 0;
int nb= 0;
int ni= 0;
int nq= 0;
int nw= 0;
//side = side.substring((1)-1,1);
//uplo = uplo.substring((1)-1,1);
//trans = trans.substring((1)-1,1);
info.val = 0;
left = com.polytechnik.lapack.Lsame.lsame(side,'L');
upper = com.polytechnik.lapack.Lsame.lsame(uplo,'U');
/***
*
*     NQ is the order of Q and NW is the minimum dimension of WORK
*
***/
lquery = ((lwork == -1));
if (left)  {
    nq = m;
nw = n;
}
else  {
  nq = n;
nw = m;
}              //  Close else.
if (((!left) && (!com.polytechnik.lapack.Lsame.lsame(side,'R'))))  {
    info.val = -1;
}
else if (((!upper) && (!com.polytechnik.lapack.Lsame.lsame(uplo,'L'))))  {
    info.val = -2;
}              // Close else if()
else if (((!com.polytechnik.lapack.Lsame.lsame(trans,'N')) && (!com.polytechnik.lapack.Lsame.lsame(trans,'T'))))  {
    info.val = -3;
}              // Close else if()
else if ((m < 0))  {
    info.val = -4;
}              // Close else if()
else if ((n < 0))  {
    info.val = -5;
}              // Close else if()
else if ((lda < Math.max(1, nq)))  {
    info.val = -7;
}              // Close else if()
else if ((ldc < Math.max(1, m)))  {
    info.val = -10;
}              // Close else if()
else if (((lwork < Math.max(1, nw)) && (!lquery)))  {
    info.val = -12;
// *
}              // Close else if()
if ((info.val == 0))  {
nb=1;
lwkopt = (Math.max(1, nw)*nb);
work[(1-(1))+ _work_offset] = (double)(lwkopt);
// *
}
if ((info.val != 0))  {
    com.polytechnik.lapack.Xerbla.xerbla("DORMTR",(-(info.val)));
    return;//Dummy.go_to("com/polytechnik/lapack/Dormtr",999999);
}
else if (lquery)  {
    return;//Dummy.go_to("com/polytechnik/lapack/Dormtr",999999);
/***
*
*     Quick return if possible
*
***/
}              // Close else if()
if ((((m == 0) || (n == 0)) || (nq == 1)))  {
    work[(1-(1))+ _work_offset] = (double)(1);
    return;//Dummy.go_to("com/polytechnik/lapack/Dormtr",999999);
// *
}
if (left)  {
    mi = (m-1);
ni = n;
}
else  {
  mi = m;
ni = (n-1);
// *
}              //  Close else.
/***
*
*        Q was determined by a call to DSYTRD with UPLO = 'U'
*
***/
if (upper)  {
    com.polytechnik.lapack.Dormql.dormql(side,trans,mi,ni,(nq-1),a,(1-(1))+(2-(1)) * (lda)+ _a_offset,lda,tau,_tau_offset,c,_c_offset,ldc,work,_work_offset,lwork,info);
/***
*
*        Q was determined by a call to DSYTRD with UPLO = 'L'
*
***/
}
else  {
  if (left)  {
    i1 = 2;
i2 = 1;
}
else  {
  i1 = 1;
i2 = 2;
}              //  Close else.
com.polytechnik.lapack.Dormqr.dormqr(side,trans,mi,ni,(nq-1),a,(2-(1))+(1-(1)) * (lda)+ _a_offset,lda,tau,_tau_offset,c,(i1-(1))+(i2-(1)) * (ldc)+ _c_offset,ldc,work,_work_offset,lwork,info);
}              //  Close else.
work[(1-(1))+ _work_offset] = (double)(lwkopt);
/***
*
*     End of DORMTR
*
***/
//Dummy.go_to("com/polytechnik/lapack/Dormtr",999999);
// dummy stmt
//Dummy.label("com/polytechnik/lapack/Dormtr",999999);
return;
   }
} // End class.
