/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dscal.f
 *  f2java version: 0.8.1
 *
 *
 *  Manually adjusted by
 *  @author Vladislav Malyshkin mal@gromco.com
 *  @version $Id: Dscal.java,v 1.4 2012/12/20 18:12:25 mal Exp $
 *
 */

package com.polytechnik.lapack;



public class Dscal {

// *> \brief \b DSCAL
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at 
// *            http://www.netlib.org/lapack/explore-html/ 
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE DSCAL(N,DA,DX,INCX)
// * 
// *       .. Scalar Arguments ..
// *       DOUBLE PRECISION DA
// *       INTEGER INCX,N
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION DX(*)
// *       ..
// *  
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *>    DSCAL scales a vector by a constant.
// *>    uses unrolled loops for increment equal to one.
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee 
// *> \author Univ. of California Berkeley 
// *> \author Univ. of Colorado Denver 
// *> \author NAG Ltd. 
// *
// *> \date November 2011
// *
// *> \ingroup double_blas_level1
// *
// *> \par Further Details:
// *  =====================
// *>
// *> \verbatim
// *>
// *>     jack dongarra, linpack, 3/11/78.
// *>     modified 3/93 to return if incx .le. 0.
// *>     modified 12/3/93, array(1) declarations changed to array(*)
// *> \endverbatim
// *>
// *  =====================================================================
// 
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
// *     ..
/***
*
*        code for increment not equal to 1
*
***/

public static void dscal (int n,
double da,
double [] dx, int _dx_offset,
int incx)  {

int i= 0;
int m= 0;
int mp1= 0;
int nincx= 0;
if (((n <= 0) || (incx <= 0))) {
    return;//Dummy.go_to("com/polytechnik/lapack/Dscal",999999);
}
    nincx = (n*incx);
{
int _i_inc = incx;
for (i = 1; (_i_inc < 0) ? i >= nincx : i <= nincx; i += _i_inc) {
dx[(i-(1))+ _dx_offset] = (da*dx[(i-(1))+ _dx_offset]);
// 
//Dummy.label("com/polytechnik/lapack/Dscal",1000000);
}              //  Close for() loop. 
}
//Dummy.go_to("com/polytechnik/lapack/Dscal",999999);
// dummy stmt
//Dummy.label("com/polytechnik/lapack/Dscal",999999);
return;
   }
} // End class.
