/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: xerbla.f
 *  f2java version: 0.8.1
 *
 *
 *  Manually adjusted by
 *  @author Vladislav Malyshkin mal@gromco.com
 *  @version $Id: Xerbla.java,v 1.3 2012/05/04 16:47:45 mal Exp $
 *
 */

package com.polytechnik.lapack;



public class Xerbla {

// *> \brief \b XERBLA
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at 
// *            http://www.netlib.org/lapack/explore-html/ 
// *
// *> \htmlonly
// *> Download XERBLA + dependencies 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a> 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a> 
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly 
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE XERBLA( SRNAME, INFO )
// * 
// *       .. Scalar Arguments ..
// *       CHARACTER*(*)      SRNAME
// *       INTEGER            INFO
// *       ..
// *  
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> XERBLA  is an error handler for the LAPACK routines.
// *> It is called by an LAPACK routine if an input parameter has an
// *> invalid value.  A message is printed and execution stops.
// *>
// *> Installers may consider modifying the STOP statement in order to
// *> call system-specific exception-handling facilities.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] SRNAME
// *> \verbatim
// *>          SRNAME is CHARACTER*(*)
// *>          The name of the routine which called XERBLA.
// *> \endverbatim
// *>
// *> \param[in] INFO
// *> \verbatim
// *>          INFO is INTEGER
// *>          The position of the invalid parameter in the parameter list

// *>          of the calling routine.
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee 
// *> \author Univ. of California Berkeley 
// *> \author Univ. of Colorado Denver 
// *> \author NAG Ltd. 
// *
// *> \date November 2011
// *
// *> \ingroup auxOTHERauxiliary
// *
// *  =====================================================================
// 
/***
*     ..
*
* =====================================================================
*
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
***/
// *

public static void xerbla (String srname,
int info)  {
    throw new RuntimeException("** On entry to "+srname+" parameter number "+info+" had an illegal value");
}

} // End class.
