package com.polytechnik.realtimebook;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** Trade item.
 *  @version $Id: Trade.java,v 1.41 2012/09/27 17:57:26 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class Trade extends BookItem {
    public static final byte
	TRADE_TYPE_REGULAR=11,
	TRADE_TYPE_NONDISPLAYABLE=12,
	TRADE_TYPE_CROSS=13,
	TRADE_TYPE_PSEUDO=114;

    public final long matchnumber;
    /** Possibly to remove to save memory? */
    public final long origtime;
    public final BookItem best_buy,best_sell;

    public final byte tradetype;
    final long sequence;

    public Trade(final double price,
		 final int shares,
		 final String attribution,
		 final byte buy_sell_indicator,
		 final long time,
		 final long matchnumber,
		 final long orderreferencenumber,
		 final long origtime,
		 final BookItem order,
		 final byte tradetype,
		 final BookItem best_buy,
		 final BookItem best_sell,
		 final long sequence)

    {
	super(price,
	      shares,
	      attribution,
	      buy_sell_indicator,
	      time,
	      orderreferencenumber,
	      order);
	this.matchnumber=matchnumber;
	this.origtime=origtime;
	this.tradetype=tradetype;
	this.best_buy=best_buy;
	this.best_sell=best_sell;
	this.sequence=sequence;
    }

    public static String getTradeDescription(final Trade t)
    {
	return t==null?"null":"(TRADEREF: pexe="+t.price+" time="+BookItem.getTimeDiag(t.time)+
	    " origtime="+BookItem.getTimeDiag(t.origtime)+
	    " shares="+t.shares+
	    " tradetype="+t.tradetype+
	    " buy_sell_indicator="+t.buy_sell_indicator+
	    " matchnumber="+t.matchnumber+
	    " orderreferencenumber="+t.orderreferencenumber+
	    " sequence="+t.sequence+
	    " ORDERREF:"+BookItem.getOrderDescription(t.order)+")";
    }


    public static Trade getDummyTrade(final double price,
				      final int shares,
				      final byte buy_sell_indicator,
				      final long time)
    {
	return new Trade(price,
			 shares,
			 null,
			 buy_sell_indicator,
			 time,
			 0,
			 0,
			 0,
			 null,
			 TRADE_TYPE_REGULAR,
			 null,
			 null,
			 -1);
    }

}
