package com.polytechnik.realtimebook;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** A circular buffer to store trades.
 *  @version $Id: TradeList.java,v 1.48 2016/03/17 00:35:58 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class TradeList extends com.polytechnik.utils.CircularList<Trade> implements  BookCopyable<Trade> {

    public final OrdersAndTrades ref;
    private final com.polytechnik.utils.TObjectProcedure<Trade> callback;

    TradeList(final int initialcapacity,
	      final com.polytechnik.utils.TObjectProcedure<Trade> callback,
	      final OrdersAndTrades ref)
    {
	super(initialcapacity);
	this.callback=callback;
	this.ref=ref;
    }
    int clearBefore(final long t0)
    {
	return clearBefore(t0,this.callback,3); // keep at least 3 element in queue
    }

public int copyTrades(final Distribution<Trade> target)
{
    final int s=getSize();
    if(s>=target.getCapacity())
    {
	target.replaceBuffer(new Trade [2*s+10]);
    }
    // there may be a lot of trades
    // copy them using System.arraycopy
    // forEachEntry is no good.
    final int bs=copyData(target.getBuffer());
    if(bs!=s||s!=getSize())
    {
	throw new java.util.ConcurrentModificationException();
    }
    target.setSize(bs);
    return s;
}

}
