package com.polytechnik.realtimebook;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** An interface between parser & trading.
 *  @version $Id: TraderInterface.java,v 1.6 2011/10/18 16:51:58 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public interface TraderInterface {

    public static final long TIME_SCALE=1000000000;



    static final int
	UPD_ADD_ORDER=1001,
	UPD_CANCEL_ORDER=1002,
	UPD_CANCELREPLACE_ORDER=1003,
	UPD_EXECUTIONORDER_TRADE=1004,
	UPD_EXECUTIONOTH_TRADE=1005,
	UPD_BROKENTRADE_TRADE=1006,


	UPD_BROKER_ORDEREXECUTED=2007,
	UPD_BROKER_ORDERADDED=2008,
	UPD_BROKER_ORDERCANCELLED=2009,
	UPD_BROKER_ORDERREJECTED=2010;



    final int SEC_TRADING_OK=45,SEC_TRADING_DISABLED=46,SEC_SHORT_NO_RES=47,SEC_SHORT_RES=48;
    /** Enable/disable trading for specific security.
     */
    void allowTrading(OrdersAndTrades ot,long currenttime,final int value,final String text);

    /** Enable/disable trading.
     */
    void allowTrading(long currenttime,boolean on_off);


    void setInstrument(OrdersAndTrades ot,
		       long currenttime,
		       boolean flag_statusOK,
		       int round_lot_shares,
		       boolean round_lot_only,
		       String market);


    void setMarketMaker(OrdersAndTrades ot,
			long currenttime,
			String mpid,
			boolean flag_primary,
			boolean flag_ok);


    void update(OrdersAndTrades ot,
		long currenttime,
		int eventid);


}
