package com.polytechnik.utils;
/**
 *  (C) Vladislav Malyshkin 1999
 *  This file is under GPL.
 */

import java.util.Vector;
import java.util.Enumeration;

/** This class is for storing error
 *  messages in an exception.
 *  @version $Id: FatalErrorMessageException.java,v 1.7 2009/07/24 20:35:00 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */

public class FatalErrorMessageException extends RuntimeException {
  private final Vector<String> vPendingMessages;
  public FatalErrorMessageException(String msg,Vector<String> vMsg)
    {
      super(msg);
      this.vPendingMessages=vMsg;
    }
  public FatalErrorMessageException(String msg)
    {
      super(msg);
      this.vPendingMessages=new Vector<String>();
      this.vPendingMessages.addElement(msg);
    }

  public Vector<String> getPendingMessages()
    {
      return this.vPendingMessages;
    }

  public int getNumberOfMessages()
    {
      return this.vPendingMessages.size();
    }

  public static final void appendMessages(Vector<String> v,FatalErrorMessageException fem)
    {
      final Vector<String> vmsg=fem.getPendingMessages();
      for(final Enumeration<String> en=vmsg.elements();en.hasMoreElements();)
      {
	  v.addElement(en.nextElement());
      }
    }
}
