package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2015
 * This file is under GPL version 3.
 *
 */

/**
 *  Calculate Nevai operator from moments.
 *  @version $Id: NevaiOperator.java,v 1.2 2015/11/03 11:30:48 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class NevaiOperator {

public static PolynomialsRatio getNevaiOperator(final int n,final double [] tmom,final double [] fmom, final OrthogonalPolynomialsABasis M)
{
    final double [] QQf=M.getQQMatr(n,fmom),QQt=M.getQQMatr(n,tmom),
	IQQt=com.polytechnik.utils.Linsystems.getInvertedMatrix(n,n,QQt);
    final double [] QQ_I_f_I=TMatr.getMatr_x_Matr(n,IQQt,n,TMatr.getMatr_x_Matr(n,QQf,n,IQQt,n),n);
    return new PolynomialsRatio(M.getKK(n,IQQt,n),M.getKK(n,QQ_I_f_I,n),M);
}
}
