package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2010
 * This file is under GPL version 3.
 *
 */

/** A crude way to find min/max by testing the values.
 *  @version $Id: SamplingMinMax.java,v 1.3 2012/12/13 21:30:05 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */

public abstract class SamplingMinMax {
    public final double f_min,x_min,f_max,x_max;
    public SamplingMinMax(final int nt,final double xl,final double xr)
    {
	double fmin=Double.POSITIVE_INFINITY,fmax=Double.NEGATIVE_INFINITY,
	    xmin=Double.NaN,xmax=Double.NaN;
	final double step=(xr-xl)/nt;
	double x=xl;
	for(int j=0;j<=nt;j++)
	{
	    final double fx=getF(x);
	    if(fx>=fmax){fmax=fx;xmax=x;}
	    if(fx<=fmin){fmin=fx;xmin=x;}
	    x+=step;
	}
	this.f_min=fmin;
	this.x_min=xmin;
	this.f_max=fmax;
	this.x_max=xmax;
    }

abstract public double getF(final double x);

}
